from __future__ import annotations
import sys
from importlib.machinery import ModuleSpec, PathFinder
from importlib.machinery import all_suffixes as module_suffixes
from importlib.util import spec_from_file_location
from itertools import chain
from pathlib import Path

MAPPING: dict[str, str] = {'Examples.paper_antireflective_coating': 'C:\\Users\\tdrumond\\Repos\\SolPOC\\Examples\\paper_antireflective_coating', 'Examples.paper_selective_coating': 'C:\\Users\\tdrumond\\Repos\\SolPOC\\Examples\\paper_selective_coating', 'Examples.paper_solar_mirror': 'C:\\Users\\tdrumond\\Repos\\SolPOC\\Examples\\paper_solar_mirror', 'Examples.tutorial_AR': 'C:\\Users\\tdrumond\\Repos\\SolPOC\\Examples\\tutorial_AR', 'Examples.tutorial_Bragg_mirror': 'C:\\Users\\tdrumond\\Repos\\SolPOC\\Examples\\tutorial_Bragg_mirror', 'Examples.tutorial_PVcells': 'C:\\Users\\tdrumond\\Repos\\SolPOC\\Examples\\tutorial_PVcells', 'Examples.tutorial_lowe_1': 'C:\\Users\\tdrumond\\Repos\\SolPOC\\Examples\\tutorial_lowe_1', 'Examples.tutorial_lowe_2': 'C:\\Users\\tdrumond\\Repos\\SolPOC\\Examples\\tutorial_lowe_2', 'Examples.tutorial_selevtive_coating': 'C:\\Users\\tdrumond\\Repos\\SolPOC\\Examples\\tutorial_selevtive_coating', 'docs': 'C:\\Users\\tdrumond\\Repos\\SolPOC\\docs', 'solpoc': 'C:\\Users\\tdrumond\\Repos\\SolPOC\\solpoc', 'venv': 'C:\\Users\\tdrumond\\Repos\\SolPOC\\venv'}
NAMESPACES: dict[str, list[str]] = {'docs': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\docs'], 'venv': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv'], 'docs.JupyterNotebook': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\docs\\JupyterNotebook'], 'Examples.paper_antireflective_coating': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\Examples\\paper_antireflective_coating'], 'Examples.paper_selective_coating': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\Examples\\paper_selective_coating'], 'Examples.paper_solar_mirror': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\Examples\\paper_solar_mirror'], 'Examples.tutorial_AR': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\Examples\\tutorial_AR'], 'Examples.tutorial_Bragg_mirror': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\Examples\\tutorial_Bragg_mirror'], 'Examples.tutorial_lowe_1': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\Examples\\tutorial_lowe_1'], 'Examples.tutorial_lowe_2': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\Examples\\tutorial_lowe_2'], 'Examples.tutorial_PVcells': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\Examples\\tutorial_PVcells'], 'Examples.tutorial_selevtive_coating': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\Examples\\tutorial_selevtive_coating'], 'solpoc.Materials': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\solpoc\\Materials'], 'solpoc.scripts': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\solpoc\\scripts'], 'venv.etc': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\etc'], 'venv.Include': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Include'], 'venv.Lib': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib'], 'venv.Scripts': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Scripts'], 'venv.share': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share'], 'venv.etc.jupyter': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\etc\\jupyter'], 'venv.etc.jupyter.nbconfig': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\etc\\jupyter\\nbconfig'], 'venv.Lib.site-packages': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages'], 'venv.Lib.site-packages.dateutil-stubs': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\dateutil-stubs'], 'venv.Lib.site-packages.mpl_toolkits': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\mpl_toolkits'], 'venv.Lib.site-packages.pythonwin': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\pythonwin'], 'venv.Lib.site-packages.pywin32_system32': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\pywin32_system32'], 'venv.Lib.site-packages.win32': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\win32'], 'venv.Lib.site-packages.win32comext': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\win32comext'], 'venv.Lib.site-packages.adodbapi.examples': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\adodbapi\\examples'], 'venv.Lib.site-packages.adodbapi.test': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\adodbapi\\test'], 'venv.Lib.site-packages.babel.locale-data': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\babel\\locale-data'], 'venv.Lib.site-packages.bs4.tests.fuzz': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\bs4\\tests\\fuzz'], 'venv.Lib.site-packages.dateutil-stubs.parser': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\dateutil-stubs\\parser'], 'venv.Lib.site-packages.dateutil-stubs.tz': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\dateutil-stubs\\tz'], 'venv.Lib.site-packages.dateutil-stubs.zoneinfo': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\dateutil-stubs\\zoneinfo'], 'venv.Lib.site-packages.debugpy._vendored.pydevd': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\debugpy\\_vendored\\pydevd'], 'venv.Lib.site-packages.debugpy._vendored.pydevd.pydevd_attach_to_process': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\debugpy\\_vendored\\pydevd\\pydevd_attach_to_process'], 'venv.Lib.site-packages.debugpy._vendored.pydevd.pydev_sitecustomize': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\debugpy\\_vendored\\pydevd\\pydev_sitecustomize'], 'venv.Lib.site-packages.debugpy._vendored.pydevd._pydevd_sys_monitoring': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\debugpy\\_vendored\\pydevd\\_pydevd_sys_monitoring'], 'venv.Lib.site-packages.debugpy._vendored.pydevd.pydevd_attach_to_process.common': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\debugpy\\_vendored\\pydevd\\pydevd_attach_to_process\\common'], 'venv.Lib.site-packages.debugpy._vendored.pydevd.pydevd_attach_to_process.linux_and_mac': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\debugpy\\_vendored\\pydevd\\pydevd_attach_to_process\\linux_and_mac'], 'venv.Lib.site-packages.debugpy._vendored.pydevd.pydevd_attach_to_process.windows': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\debugpy\\_vendored\\pydevd\\pydevd_attach_to_process\\windows'], 'venv.Lib.site-packages.h11.tests.data': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\h11\\tests\\data'], 'venv.Lib.site-packages.ipykernel.resources': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\ipykernel\\resources'], 'venv.Lib.site-packages.IPython.core.profile': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\IPython\\core\\profile'], 'venv.Lib.site-packages.IPython.core.tests.daft_extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\IPython\\core\\tests\\daft_extension'], 'venv.Lib.site-packages.ipywidgets.widgets.tests.data': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\ipywidgets\\widgets\\tests\\data'], 'venv.Lib.site-packages.isapi.doc': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\isapi\\doc'], 'venv.Lib.site-packages.isapi.samples': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\isapi\\samples'], 'venv.Lib.site-packages.isapi.test': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\isapi\\test'], 'venv.Lib.site-packages.jedi.third_party': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party'], 'venv.Lib.site-packages.jedi.third_party.django-stubs': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs'], 'venv.Lib.site-packages.jedi.third_party.typeshed': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.apps': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\apps'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.conf': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\conf'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.contrib': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\contrib'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.core': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\core'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.db': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\db'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.dispatch': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\dispatch'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.forms': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\forms'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.http': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\http'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.middleware': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\middleware'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.template': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\template'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.templatetags': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\templatetags'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.test': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\test'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.urls': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\urls'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.utils': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\utils'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.views': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\views'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.conf.locale': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\conf\\locale'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.conf.urls': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\conf\\urls'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.contrib.admin': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\contrib\\admin'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.contrib.admindocs': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\contrib\\admindocs'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.contrib.auth': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\contrib\\auth'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.contrib.contenttypes': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\contrib\\contenttypes'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.contrib.flatpages': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\contrib\\flatpages'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.contrib.gis': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\contrib\\gis'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.contrib.humanize': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\contrib\\humanize'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.contrib.messages': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\contrib\\messages'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.contrib.postgres': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\contrib\\postgres'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.contrib.redirects': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\contrib\\redirects'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.contrib.sessions': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\contrib\\sessions'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.contrib.sitemaps': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\contrib\\sitemaps'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.contrib.sites': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\contrib\\sites'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.contrib.staticfiles': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\contrib\\staticfiles'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.contrib.syndication': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\contrib\\syndication'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.contrib.admin.templatetags': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\contrib\\admin\\templatetags'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.contrib.admin.views': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\contrib\\admin\\views'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.contrib.auth.handlers': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\contrib\\auth\\handlers'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.contrib.auth.management': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\contrib\\auth\\management'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.contrib.auth.management.commands': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\contrib\\auth\\management\\commands'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.contrib.contenttypes.management': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\contrib\\contenttypes\\management'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.contrib.contenttypes.management.commands': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\contrib\\contenttypes\\management\\commands'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.contrib.flatpages.templatetags': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\contrib\\flatpages\\templatetags'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.contrib.gis.db': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\contrib\\gis\\db'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.contrib.gis.db.models': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\contrib\\gis\\db\\models'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.contrib.humanize.templatetags': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\contrib\\humanize\\templatetags'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.contrib.messages.storage': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\contrib\\messages\\storage'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.contrib.postgres.aggregates': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\contrib\\postgres\\aggregates'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.contrib.postgres.fields': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\contrib\\postgres\\fields'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.contrib.sessions.backends': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\contrib\\sessions\\backends'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.contrib.sessions.management': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\contrib\\sessions\\management'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.contrib.sessions.management.commands': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\contrib\\sessions\\management\\commands'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.contrib.sitemaps.management': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\contrib\\sitemaps\\management'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.contrib.sitemaps.management.commands': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\contrib\\sitemaps\\management\\commands'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.contrib.staticfiles.management': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\contrib\\staticfiles\\management'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.contrib.staticfiles.templatetags': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\contrib\\staticfiles\\templatetags'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.contrib.staticfiles.management.commands': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\contrib\\staticfiles\\management\\commands'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.core.cache': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\core\\cache'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.core.checks': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\core\\checks'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.core.files': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\core\\files'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.core.handlers': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\core\\handlers'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.core.mail': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\core\\mail'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.core.management': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\core\\management'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.core.serializers': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\core\\serializers'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.core.servers': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\core\\servers'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.core.cache.backends': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\core\\cache\\backends'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.core.checks.security': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\core\\checks\\security'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.core.mail.backends': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\core\\mail\\backends'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.core.management.commands': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\core\\management\\commands'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.db.backends': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\db\\backends'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.db.migrations': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\db\\migrations'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.db.models': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\db\\models'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.db.backends.base': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\db\\backends\\base'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.db.backends.dummy': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\db\\backends\\dummy'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.db.backends.mysql': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\db\\backends\\mysql'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.db.backends.postgresql': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\db\\backends\\postgresql'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.db.backends.sqlite3': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\db\\backends\\sqlite3'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.db.migrations.operations': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\db\\migrations\\operations'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.db.models.fields': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\db\\models\\fields'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.db.models.functions': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\db\\models\\functions'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.db.models.sql': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\db\\models\\sql'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.template.backends': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\template\\backends'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.template.loaders': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\template\\loaders'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.utils.translation': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\utils\\translation'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.views.decorators': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\views\\decorators'], 'venv.Lib.site-packages.jedi.third_party.django-stubs.django-stubs.views.generic': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\django-stubs\\django-stubs\\views\\generic'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.2': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\2'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.2and3': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\2and3'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.3': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\3'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.2.distutils': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\2\\distutils'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.2.email': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\2\\email'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.2.encodings': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\2\\encodings'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.2.multiprocessing': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\2\\multiprocessing'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.2.os': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\2\\os'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.2.distutils.command': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\2\\distutils\\command'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.2.email.mime': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\2\\email\\mime'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.2.multiprocessing.dummy': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\2\\multiprocessing\\dummy'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.2and3.ctypes': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\2and3\\ctypes'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.2and3.curses': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\2and3\\curses'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.2and3.ensurepip': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\2and3\\ensurepip'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.2and3.lib2to3': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\2and3\\lib2to3'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.2and3.logging': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\2and3\\logging'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.2and3.msilib': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\2and3\\msilib'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.2and3.pydoc_data': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\2and3\\pydoc_data'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.2and3.pyexpat': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\2and3\\pyexpat'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.2and3.sqlite3': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\2and3\\sqlite3'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.2and3.wsgiref': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\2and3\\wsgiref'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.2and3.xml': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\2and3\\xml'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.2and3._typeshed': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\2and3\\_typeshed'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.2and3.lib2to3.pgen2': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\2and3\\lib2to3\\pgen2'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.2and3.xml.dom': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\2and3\\xml\\dom'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.2and3.xml.etree': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\2and3\\xml\\etree'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.2and3.xml.parsers': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\2and3\\xml\\parsers'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.2and3.xml.sax': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\2and3\\xml\\sax'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.2and3.xml.parsers.expat': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\2and3\\xml\\parsers\\expat'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.3.asyncio': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\3\\asyncio'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.3.collections': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\3\\collections'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.3.concurrent': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\3\\concurrent'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.3.dbm': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\3\\dbm'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.3.distutils': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\3\\distutils'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.3.email': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\3\\email'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.3.encodings': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\3\\encodings'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.3.html': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\3\\html'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.3.http': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\3\\http'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.3.importlib': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\3\\importlib'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.3.json': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\3\\json'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.3.multiprocessing': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\3\\multiprocessing'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.3.os': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\3\\os'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.3.tkinter': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\3\\tkinter'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.3.unittest': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\3\\unittest'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.3.urllib': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\3\\urllib'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.3.venv': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\3\\venv'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.3.xmlrpc': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\3\\xmlrpc'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.3.concurrent.futures': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\3\\concurrent\\futures'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.3.distutils.command': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\3\\distutils\\command'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.3.email.mime': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\3\\email\\mime'], 'venv.Lib.site-packages.jedi.third_party.typeshed.stdlib.3.multiprocessing.dummy': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\stdlib\\3\\multiprocessing\\dummy'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.3': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\3'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2.concurrent': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2\\concurrent'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2.fb303': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2\\fb303'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2.kazoo': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2\\kazoo'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2.OpenSSL': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2\\OpenSSL'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2.routes': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2\\routes'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2.scribe': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2\\scribe'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2.six': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2\\six'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2.tornado': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2\\tornado'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2.concurrent.futures': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2\\concurrent\\futures'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2.kazoo.recipe': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2\\kazoo\\recipe'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2.six.moves': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2\\six\\moves'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2.six.moves.urllib': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2\\six\\moves\\urllib'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.atomicwrites': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\atomicwrites'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.attr': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\attr'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.backports': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\backports'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.bleach': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\bleach'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.boto': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\boto'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.cachetools': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\cachetools'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.characteristic': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\characteristic'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.chardet': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\chardet'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.click': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\click'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.cryptography': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\cryptography'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.datetimerange': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\datetimerange'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.dateutil': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\dateutil'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.deprecated': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\deprecated'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.emoji': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\emoji'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.flask': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\flask'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.geoip2': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\geoip2'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.google': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\google'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.jinja2': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\jinja2'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.markdown': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\markdown'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.markupsafe': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\markupsafe'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.maxminddb': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\maxminddb'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.nmap': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\nmap'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.paramiko': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\paramiko'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.pymysql': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\pymysql'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.pynamodb': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\pynamodb'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.pytz': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\pytz'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.pyVmomi': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\pyVmomi'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.redis': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\redis'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.requests': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\requests'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.retry': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\retry'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.simplejson': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\simplejson'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.slugify': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\slugify'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.tzlocal': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\tzlocal'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.werkzeug': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\werkzeug'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.yaml': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\yaml'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.boto.ec2': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\boto\\ec2'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.boto.elb': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\boto\\elb'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.boto.kms': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\boto\\kms'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.boto.s3': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\boto\\s3'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.cryptography.hazmat': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\cryptography\\hazmat'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.cryptography.x509': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\cryptography\\x509'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.cryptography.hazmat.backends': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\cryptography\\hazmat\\backends'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.cryptography.hazmat.bindings': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\cryptography\\hazmat\\bindings'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.cryptography.hazmat.primitives': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\cryptography\\hazmat\\primitives'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.cryptography.hazmat.bindings.openssl': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\cryptography\\hazmat\\bindings\\openssl'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.cryptography.hazmat.primitives.asymmetric': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\cryptography\\hazmat\\primitives\\asymmetric'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.cryptography.hazmat.primitives.ciphers': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\cryptography\\hazmat\\primitives\\ciphers'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.cryptography.hazmat.primitives.kdf': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\cryptography\\hazmat\\primitives\\kdf'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.cryptography.hazmat.primitives.serialization': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\cryptography\\hazmat\\primitives\\serialization'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.cryptography.hazmat.primitives.twofactor': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\cryptography\\hazmat\\primitives\\twofactor'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.dateutil.tz': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\dateutil\\tz'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.flask.json': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\flask\\json'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.google.protobuf': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\google\\protobuf'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.google.protobuf.compiler': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\google\\protobuf\\compiler'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.google.protobuf.internal': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\google\\protobuf\\internal'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.google.protobuf.util': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\google\\protobuf\\util'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.markdown.extensions': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\markdown\\extensions'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.pymysql.constants': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\pymysql\\constants'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.pynamodb.connection': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\pynamodb\\connection'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.pyVmomi.vim': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\pyVmomi\\vim'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.pyVmomi.vmodl': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\pyVmomi\\vmodl'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.requests.packages': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\requests\\packages'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.requests.packages.urllib3': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\requests\\packages\\urllib3'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.requests.packages.urllib3.contrib': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\requests\\packages\\urllib3\\contrib'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.requests.packages.urllib3.packages': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\requests\\packages\\urllib3\\packages'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.requests.packages.urllib3.util': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\requests\\packages\\urllib3\\util'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.requests.packages.urllib3.packages.ssl_match_hostname': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\requests\\packages\\urllib3\\packages\\ssl_match_hostname'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.werkzeug.contrib': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\werkzeug\\contrib'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.werkzeug.debug': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\werkzeug\\debug'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.2and3.werkzeug.middleware': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\2and3\\werkzeug\\middleware'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.3.aiofiles': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\3\\aiofiles'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.3.docutils': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\3\\docutils'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.3.filelock': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\3\\filelock'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.3.freezegun': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\3\\freezegun'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.3.jwt': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\3\\jwt'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.3.pkg_resources': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\3\\pkg_resources'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.3.pyrfc3339': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\3\\pyrfc3339'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.3.six': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\3\\six'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.3.typed_ast': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\3\\typed_ast'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.3.waitress': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\3\\waitress'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.3.aiofiles.threadpool': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\3\\aiofiles\\threadpool'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.3.docutils.parsers': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\3\\docutils\\parsers'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.3.docutils.parsers.rst': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\3\\docutils\\parsers\\rst'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.3.jwt.contrib': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\3\\jwt\\contrib'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.3.jwt.contrib.algorithms': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\3\\jwt\\contrib\\algorithms'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.3.six.moves': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\3\\six\\moves'], 'venv.Lib.site-packages.jedi.third_party.typeshed.third_party.3.six.moves.urllib': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jedi\\third_party\\typeshed\\third_party\\3\\six\\moves\\urllib'], 'venv.Lib.site-packages.jsonschema.benchmarks.issue232': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jsonschema\\benchmarks\\issue232'], 'venv.Lib.site-packages.jsonschema_specifications.schemas': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jsonschema_specifications\\schemas'], 'venv.Lib.site-packages.jsonschema_specifications.schemas.draft201909': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jsonschema_specifications\\schemas\\draft201909'], 'venv.Lib.site-packages.jsonschema_specifications.schemas.draft202012': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jsonschema_specifications\\schemas\\draft202012'], 'venv.Lib.site-packages.jsonschema_specifications.schemas.draft3': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jsonschema_specifications\\schemas\\draft3'], 'venv.Lib.site-packages.jsonschema_specifications.schemas.draft4': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jsonschema_specifications\\schemas\\draft4'], 'venv.Lib.site-packages.jsonschema_specifications.schemas.draft6': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jsonschema_specifications\\schemas\\draft6'], 'venv.Lib.site-packages.jsonschema_specifications.schemas.draft7': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jsonschema_specifications\\schemas\\draft7'], 'venv.Lib.site-packages.jsonschema_specifications.schemas.draft201909.vocabularies': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jsonschema_specifications\\schemas\\draft201909\\vocabularies'], 'venv.Lib.site-packages.jsonschema_specifications.schemas.draft202012.vocabularies': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jsonschema_specifications\\schemas\\draft202012\\vocabularies'], 'venv.Lib.site-packages.jupyterlab.schemas': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\schemas'], 'venv.Lib.site-packages.jupyterlab.staging': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\staging'], 'venv.Lib.site-packages.jupyterlab.static': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\static'], 'venv.Lib.site-packages.jupyterlab.themes': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\themes'], 'venv.Lib.site-packages.jupyterlab.galata.@jupyterlab': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\galata\\@jupyterlab'], 'venv.Lib.site-packages.jupyterlab.galata.@jupyterlab.galata-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\galata\\@jupyterlab\\galata-extension'], 'venv.Lib.site-packages.jupyterlab.galata.@jupyterlab.galata-extension.static': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\galata\\@jupyterlab\\galata-extension\\static'], 'venv.Lib.site-packages.jupyterlab.schemas.@jupyterlab': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\schemas\\@jupyterlab'], 'venv.Lib.site-packages.jupyterlab.schemas.@jupyterlab.application-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\schemas\\@jupyterlab\\application-extension'], 'venv.Lib.site-packages.jupyterlab.schemas.@jupyterlab.apputils-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\schemas\\@jupyterlab\\apputils-extension'], 'venv.Lib.site-packages.jupyterlab.schemas.@jupyterlab.cell-toolbar-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\schemas\\@jupyterlab\\cell-toolbar-extension'], 'venv.Lib.site-packages.jupyterlab.schemas.@jupyterlab.celltags-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\schemas\\@jupyterlab\\celltags-extension'], 'venv.Lib.site-packages.jupyterlab.schemas.@jupyterlab.codemirror-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\schemas\\@jupyterlab\\codemirror-extension'], 'venv.Lib.site-packages.jupyterlab.schemas.@jupyterlab.completer-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\schemas\\@jupyterlab\\completer-extension'], 'venv.Lib.site-packages.jupyterlab.schemas.@jupyterlab.console-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\schemas\\@jupyterlab\\console-extension'], 'venv.Lib.site-packages.jupyterlab.schemas.@jupyterlab.csvviewer-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\schemas\\@jupyterlab\\csvviewer-extension'], 'venv.Lib.site-packages.jupyterlab.schemas.@jupyterlab.debugger-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\schemas\\@jupyterlab\\debugger-extension'], 'venv.Lib.site-packages.jupyterlab.schemas.@jupyterlab.docmanager-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\schemas\\@jupyterlab\\docmanager-extension'], 'venv.Lib.site-packages.jupyterlab.schemas.@jupyterlab.documentsearch-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\schemas\\@jupyterlab\\documentsearch-extension'], 'venv.Lib.site-packages.jupyterlab.schemas.@jupyterlab.extensionmanager-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\schemas\\@jupyterlab\\extensionmanager-extension'], 'venv.Lib.site-packages.jupyterlab.schemas.@jupyterlab.filebrowser-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\schemas\\@jupyterlab\\filebrowser-extension'], 'venv.Lib.site-packages.jupyterlab.schemas.@jupyterlab.fileeditor-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\schemas\\@jupyterlab\\fileeditor-extension'], 'venv.Lib.site-packages.jupyterlab.schemas.@jupyterlab.help-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\schemas\\@jupyterlab\\help-extension'], 'venv.Lib.site-packages.jupyterlab.schemas.@jupyterlab.htmlviewer-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\schemas\\@jupyterlab\\htmlviewer-extension'], 'venv.Lib.site-packages.jupyterlab.schemas.@jupyterlab.hub-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\schemas\\@jupyterlab\\hub-extension'], 'venv.Lib.site-packages.jupyterlab.schemas.@jupyterlab.imageviewer-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\schemas\\@jupyterlab\\imageviewer-extension'], 'venv.Lib.site-packages.jupyterlab.schemas.@jupyterlab.inspector-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\schemas\\@jupyterlab\\inspector-extension'], 'venv.Lib.site-packages.jupyterlab.schemas.@jupyterlab.launcher-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\schemas\\@jupyterlab\\launcher-extension'], 'venv.Lib.site-packages.jupyterlab.schemas.@jupyterlab.logconsole-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\schemas\\@jupyterlab\\logconsole-extension'], 'venv.Lib.site-packages.jupyterlab.schemas.@jupyterlab.lsp-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\schemas\\@jupyterlab\\lsp-extension'], 'venv.Lib.site-packages.jupyterlab.schemas.@jupyterlab.mainmenu-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\schemas\\@jupyterlab\\mainmenu-extension'], 'venv.Lib.site-packages.jupyterlab.schemas.@jupyterlab.markdownviewer-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\schemas\\@jupyterlab\\markdownviewer-extension'], 'venv.Lib.site-packages.jupyterlab.schemas.@jupyterlab.mathjax-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\schemas\\@jupyterlab\\mathjax-extension'], 'venv.Lib.site-packages.jupyterlab.schemas.@jupyterlab.metadataform-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\schemas\\@jupyterlab\\metadataform-extension'], 'venv.Lib.site-packages.jupyterlab.schemas.@jupyterlab.notebook-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\schemas\\@jupyterlab\\notebook-extension'], 'venv.Lib.site-packages.jupyterlab.schemas.@jupyterlab.running-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\schemas\\@jupyterlab\\running-extension'], 'venv.Lib.site-packages.jupyterlab.schemas.@jupyterlab.settingeditor-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\schemas\\@jupyterlab\\settingeditor-extension'], 'venv.Lib.site-packages.jupyterlab.schemas.@jupyterlab.shortcuts-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\schemas\\@jupyterlab\\shortcuts-extension'], 'venv.Lib.site-packages.jupyterlab.schemas.@jupyterlab.statusbar-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\schemas\\@jupyterlab\\statusbar-extension'], 'venv.Lib.site-packages.jupyterlab.schemas.@jupyterlab.terminal-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\schemas\\@jupyterlab\\terminal-extension'], 'venv.Lib.site-packages.jupyterlab.schemas.@jupyterlab.toc-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\schemas\\@jupyterlab\\toc-extension'], 'venv.Lib.site-packages.jupyterlab.schemas.@jupyterlab.tooltip-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\schemas\\@jupyterlab\\tooltip-extension'], 'venv.Lib.site-packages.jupyterlab.schemas.@jupyterlab.translation-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\schemas\\@jupyterlab\\translation-extension'], 'venv.Lib.site-packages.jupyterlab.schemas.@jupyterlab.workspaces-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\schemas\\@jupyterlab\\workspaces-extension'], 'venv.Lib.site-packages.jupyterlab.staging.templates': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\staging\\templates'], 'venv.Lib.site-packages.jupyterlab.tests.mock_packages': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\tests\\mock_packages'], 'venv.Lib.site-packages.jupyterlab.tests.mock_packages.extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\tests\\mock_packages\\extension'], 'venv.Lib.site-packages.jupyterlab.tests.mock_packages.incompat': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\tests\\mock_packages\\incompat'], 'venv.Lib.site-packages.jupyterlab.tests.mock_packages.interop': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\tests\\mock_packages\\interop'], 'venv.Lib.site-packages.jupyterlab.tests.mock_packages.mimeextension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\tests\\mock_packages\\mimeextension'], 'venv.Lib.site-packages.jupyterlab.tests.mock_packages.package': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\tests\\mock_packages\\package'], 'venv.Lib.site-packages.jupyterlab.tests.mock_packages.test-hyphens': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\tests\\mock_packages\\test-hyphens'], 'venv.Lib.site-packages.jupyterlab.tests.mock_packages.test-hyphens-underscore': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\tests\\mock_packages\\test-hyphens-underscore'], 'venv.Lib.site-packages.jupyterlab.tests.mock_packages.test_no_hyphens': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\tests\\mock_packages\\test_no_hyphens'], 'venv.Lib.site-packages.jupyterlab.tests.mock_packages.interop.consumer': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\tests\\mock_packages\\interop\\consumer'], 'venv.Lib.site-packages.jupyterlab.tests.mock_packages.interop.provider': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\tests\\mock_packages\\interop\\provider'], 'venv.Lib.site-packages.jupyterlab.tests.mock_packages.interop.token': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\tests\\mock_packages\\interop\\token'], 'venv.Lib.site-packages.jupyterlab.themes.@jupyterlab': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\themes\\@jupyterlab'], 'venv.Lib.site-packages.jupyterlab.themes.@jupyterlab.theme-dark-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\themes\\@jupyterlab\\theme-dark-extension'], 'venv.Lib.site-packages.jupyterlab.themes.@jupyterlab.theme-dark-high-contrast-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\themes\\@jupyterlab\\theme-dark-high-contrast-extension'], 'venv.Lib.site-packages.jupyterlab.themes.@jupyterlab.theme-light-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab\\themes\\@jupyterlab\\theme-light-extension'], 'venv.Lib.site-packages.jupyterlab_server.templates': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab_server\\templates'], 'venv.Lib.site-packages.jupyterlab_server.test_data': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab_server\\test_data'], 'venv.Lib.site-packages.jupyterlab_server.test_data.app-settings': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab_server\\test_data\\app-settings'], 'venv.Lib.site-packages.jupyterlab_server.test_data.schemas': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab_server\\test_data\\schemas'], 'venv.Lib.site-packages.jupyterlab_server.test_data.workspaces': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab_server\\test_data\\workspaces'], 'venv.Lib.site-packages.jupyterlab_server.test_data.schemas.@jupyterlab': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab_server\\test_data\\schemas\\@jupyterlab'], 'venv.Lib.site-packages.jupyterlab_server.test_data.schemas.@jupyterlab.apputils-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab_server\\test_data\\schemas\\@jupyterlab\\apputils-extension'], 'venv.Lib.site-packages.jupyterlab_server.test_data.schemas.@jupyterlab.codemirror-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab_server\\test_data\\schemas\\@jupyterlab\\codemirror-extension'], 'venv.Lib.site-packages.jupyterlab_server.test_data.schemas.@jupyterlab.shortcuts-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab_server\\test_data\\schemas\\@jupyterlab\\shortcuts-extension'], 'venv.Lib.site-packages.jupyterlab_server.test_data.schemas.@jupyterlab.translation-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab_server\\test_data\\schemas\\@jupyterlab\\translation-extension'], 'venv.Lib.site-packages.jupyterlab_server.test_data.schemas.@jupyterlab.unicode-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyterlab_server\\test_data\\schemas\\@jupyterlab\\unicode-extension'], 'venv.Lib.site-packages.jupyter_events.schemas': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyter_events\\schemas'], 'venv.Lib.site-packages.jupyter_lsp.etc': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyter_lsp\\etc'], 'venv.Lib.site-packages.jupyter_server.event_schemas': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyter_server\\event_schemas'], 'venv.Lib.site-packages.jupyter_server.static': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyter_server\\static'], 'venv.Lib.site-packages.jupyter_server.templates': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyter_server\\templates'], 'venv.Lib.site-packages.jupyter_server.event_schemas.contents_service': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyter_server\\event_schemas\\contents_service'], 'venv.Lib.site-packages.jupyter_server.event_schemas.gateway_client': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyter_server\\event_schemas\\gateway_client'], 'venv.Lib.site-packages.jupyter_server.event_schemas.kernel_actions': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyter_server\\event_schemas\\kernel_actions'], 'venv.Lib.site-packages.jupyter_server.i18n.zh_CN': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyter_server\\i18n\\zh_CN'], 'venv.Lib.site-packages.jupyter_server.i18n.zh_CN.LC_MESSAGES': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyter_server\\i18n\\zh_CN\\LC_MESSAGES'], 'venv.Lib.site-packages.jupyter_server.static.favicons': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyter_server\\static\\favicons'], 'venv.Lib.site-packages.jupyter_server.static.logo': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyter_server\\static\\logo'], 'venv.Lib.site-packages.jupyter_server.static.style': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\jupyter_server\\static\\style'], 'venv.Lib.site-packages.matplotlib.mpl-data': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\matplotlib\\mpl-data'], 'venv.Lib.site-packages.matplotlib.backends.web_backend': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\matplotlib\\backends\\web_backend'], 'venv.Lib.site-packages.matplotlib.backends.web_backend.css': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\matplotlib\\backends\\web_backend\\css'], 'venv.Lib.site-packages.matplotlib.backends.web_backend.js': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\matplotlib\\backends\\web_backend\\js'], 'venv.Lib.site-packages.matplotlib.mpl-data.fonts': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\matplotlib\\mpl-data\\fonts'], 'venv.Lib.site-packages.matplotlib.mpl-data.images': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\matplotlib\\mpl-data\\images'], 'venv.Lib.site-packages.matplotlib.mpl-data.plot_directive': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\matplotlib\\mpl-data\\plot_directive'], 'venv.Lib.site-packages.matplotlib.mpl-data.sample_data': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\matplotlib\\mpl-data\\sample_data'], 'venv.Lib.site-packages.matplotlib.mpl-data.stylelib': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\matplotlib\\mpl-data\\stylelib'], 'venv.Lib.site-packages.matplotlib.mpl-data.fonts.afm': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\matplotlib\\mpl-data\\fonts\\afm'], 'venv.Lib.site-packages.matplotlib.mpl-data.fonts.pdfcorefonts': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\matplotlib\\mpl-data\\fonts\\pdfcorefonts'], 'venv.Lib.site-packages.matplotlib.mpl-data.fonts.ttf': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\matplotlib\\mpl-data\\fonts\\ttf'], 'venv.Lib.site-packages.matplotlib.mpl-data.sample_data.axes_grid': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\matplotlib\\mpl-data\\sample_data\\axes_grid'], 'venv.Lib.site-packages.nbconvert.templates': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\nbconvert\\templates'], 'venv.Lib.site-packages.nbconvert.templates.skeleton': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\nbconvert\\templates\\skeleton'], 'venv.Lib.site-packages.notebook.custom': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\notebook\\custom'], 'venv.Lib.site-packages.notebook.static': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\notebook\\static'], 'venv.Lib.site-packages.notebook.templates': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\notebook\\templates'], 'venv.Lib.site-packages.notebook_shim.tests.confs': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\notebook_shim\\tests\\confs'], 'venv.Lib.site-packages.numpy.doc': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\doc'], 'venv.Lib.site-packages.numpy.distutils.checks': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\distutils\\checks'], 'venv.Lib.site-packages.numpy.distutils.mingw': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\distutils\\mingw'], 'venv.Lib.site-packages.numpy.f2py.src': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\f2py\\src'], 'venv.Lib.site-packages.numpy.f2py.tests.src': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src'], 'venv.Lib.site-packages.numpy.f2py.tests.src.abstract_interface': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\abstract_interface'], 'venv.Lib.site-packages.numpy.f2py.tests.src.array_from_pyobj': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\array_from_pyobj'], 'venv.Lib.site-packages.numpy.f2py.tests.src.assumed_shape': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\assumed_shape'], 'venv.Lib.site-packages.numpy.f2py.tests.src.block_docstring': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\block_docstring'], 'venv.Lib.site-packages.numpy.f2py.tests.src.callback': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\callback'], 'venv.Lib.site-packages.numpy.f2py.tests.src.cli': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\cli'], 'venv.Lib.site-packages.numpy.f2py.tests.src.common': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\common'], 'venv.Lib.site-packages.numpy.f2py.tests.src.crackfortran': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\crackfortran'], 'venv.Lib.site-packages.numpy.f2py.tests.src.f2cmap': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\f2cmap'], 'venv.Lib.site-packages.numpy.f2py.tests.src.isocintrin': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\isocintrin'], 'venv.Lib.site-packages.numpy.f2py.tests.src.kind': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\kind'], 'venv.Lib.site-packages.numpy.f2py.tests.src.mixed': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\mixed'], 'venv.Lib.site-packages.numpy.f2py.tests.src.modules': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\modules'], 'venv.Lib.site-packages.numpy.f2py.tests.src.negative_bounds': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\negative_bounds'], 'venv.Lib.site-packages.numpy.f2py.tests.src.parameter': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\parameter'], 'venv.Lib.site-packages.numpy.f2py.tests.src.quoted_character': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\quoted_character'], 'venv.Lib.site-packages.numpy.f2py.tests.src.regression': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\regression'], 'venv.Lib.site-packages.numpy.f2py.tests.src.return_character': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\return_character'], 'venv.Lib.site-packages.numpy.f2py.tests.src.return_complex': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\return_complex'], 'venv.Lib.site-packages.numpy.f2py.tests.src.return_integer': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\return_integer'], 'venv.Lib.site-packages.numpy.f2py.tests.src.return_logical': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\return_logical'], 'venv.Lib.site-packages.numpy.f2py.tests.src.return_real': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\return_real'], 'venv.Lib.site-packages.numpy.f2py.tests.src.size': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\size'], 'venv.Lib.site-packages.numpy.f2py.tests.src.string': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\string'], 'venv.Lib.site-packages.numpy.f2py.tests.src.value_attrspec': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\value_attrspec'], 'venv.Lib.site-packages.numpy.f2py.tests.src.modules.gh25337': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\modules\\gh25337'], 'venv.Lib.site-packages.numpy.f2py.tests.src.modules.gh26920': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\modules\\gh26920'], 'venv.Lib.site-packages.numpy.lib.tests.data': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\lib\\tests\\data'], 'venv.Lib.site-packages.numpy.random.lib': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\random\\lib'], 'venv.Lib.site-packages.numpy.random._examples': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\random\\_examples'], 'venv.Lib.site-packages.numpy.random._examples.cffi': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\random\\_examples\\cffi'], 'venv.Lib.site-packages.numpy.random._examples.cython': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\random\\_examples\\cython'], 'venv.Lib.site-packages.numpy.random._examples.numba': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\random\\_examples\\numba'], 'venv.Lib.site-packages.numpy.typing.tests.data': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\typing\\tests\\data'], 'venv.Lib.site-packages.numpy.typing.tests.data.fail': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\typing\\tests\\data\\fail'], 'venv.Lib.site-packages.numpy.typing.tests.data.misc': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\typing\\tests\\data\\misc'], 'venv.Lib.site-packages.numpy.typing.tests.data.pass': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\typing\\tests\\data\\pass'], 'venv.Lib.site-packages.numpy.typing.tests.data.reveal': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\typing\\tests\\data\\reveal'], 'venv.Lib.site-packages.numpy._core.include': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\_core\\include'], 'venv.Lib.site-packages.numpy._core.lib': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\_core\\lib'], 'venv.Lib.site-packages.numpy._core.tests': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\_core\\tests'], 'venv.Lib.site-packages.numpy._core.include.numpy': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\_core\\include\\numpy'], 'venv.Lib.site-packages.numpy._core.include.numpy.random': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\_core\\include\\numpy\\random'], 'venv.Lib.site-packages.numpy._core.lib.npy-pkg-config': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\_core\\lib\\npy-pkg-config'], 'venv.Lib.site-packages.numpy._core.lib.pkgconfig': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\_core\\lib\\pkgconfig'], 'venv.Lib.site-packages.numpy._core.tests.data': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\_core\\tests\\data'], 'venv.Lib.site-packages.numpy._core.tests.examples': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\_core\\tests\\examples'], 'venv.Lib.site-packages.numpy._core.tests.examples.cython': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\_core\\tests\\examples\\cython'], 'venv.Lib.site-packages.numpy._core.tests.examples.limited_api': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\numpy\\_core\\tests\\examples\\limited_api'], 'venv.Lib.site-packages.pythonwin.pywin.Demos': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\pythonwin\\pywin\\Demos'], 'venv.Lib.site-packages.pythonwin.pywin.Demos.app': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\pythonwin\\pywin\\Demos\\app'], 'venv.Lib.site-packages.scipy.interpolate.tests.data': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\scipy\\interpolate\\tests\\data'], 'venv.Lib.site-packages.scipy.io.arff.tests.data': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\scipy\\io\\arff\\tests\\data'], 'venv.Lib.site-packages.scipy.io.matlab.tests.data': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\scipy\\io\\matlab\\tests\\data'], 'venv.Lib.site-packages.scipy.io.tests.data': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\scipy\\io\\tests\\data'], 'venv.Lib.site-packages.scipy.linalg.tests.data': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\scipy\\linalg\\tests\\data'], 'venv.Lib.site-packages.scipy.linalg.tests._cython_examples': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\scipy\\linalg\\tests\\_cython_examples'], 'venv.Lib.site-packages.scipy.ndimage.tests.data': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\scipy\\ndimage\\tests\\data'], 'venv.Lib.site-packages.scipy.optimize.tests._cython_examples': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\scipy\\optimize\\tests\\_cython_examples'], 'venv.Lib.site-packages.scipy.optimize._highs.src': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\scipy\\optimize\\_highs\\src'], 'venv.Lib.site-packages.scipy.optimize._highs.src.cython': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\scipy\\optimize\\_highs\\src\\cython'], 'venv.Lib.site-packages.scipy.sparse.linalg._propack': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\scipy\\sparse\\linalg\\_propack'], 'venv.Lib.site-packages.scipy.sparse.tests.data': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\scipy\\sparse\\tests\\data'], 'venv.Lib.site-packages.scipy.spatial.qhull_src': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\scipy\\spatial\\qhull_src'], 'venv.Lib.site-packages.scipy.spatial.tests.data': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\scipy\\spatial\\tests\\data'], 'venv.Lib.site-packages.scipy.special.special': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\scipy\\special\\special'], 'venv.Lib.site-packages.scipy.special.special.cephes': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\scipy\\special\\special\\cephes'], 'venv.Lib.site-packages.scipy.special.tests._cython_examples': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\scipy\\special\\tests\\_cython_examples'], 'venv.Lib.site-packages.scipy.stats.tests.data': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\scipy\\stats\\tests\\data'], 'venv.Lib.site-packages.scipy.stats.tests.data.levy_stable': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\scipy\\stats\\tests\\data\\levy_stable'], 'venv.Lib.site-packages.scipy.stats.tests.data.nist_anova': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\scipy\\stats\\tests\\data\\nist_anova'], 'venv.Lib.site-packages.scipy.stats.tests.data.nist_linregress': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\scipy\\stats\\tests\\data\\nist_linregress'], 'venv.Lib.site-packages.solcore.material_data.Adachi': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\solcore\\material_data\\Adachi'], 'venv.Lib.site-packages.solcore.material_data.AlAs-Material': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\solcore\\material_data\\AlAs-Material'], 'venv.Lib.site-packages.solcore.material_data.GaAs-Material': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\solcore\\material_data\\GaAs-Material'], 'venv.Lib.site-packages.solcore.material_data.GaSb-Material': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\solcore\\material_data\\GaSb-Material'], 'venv.Lib.site-packages.solcore.material_data.Ge-Material': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\solcore\\material_data\\Ge-Material'], 'venv.Lib.site-packages.solcore.material_data.InP-Material': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\solcore\\material_data\\InP-Material'], 'venv.Lib.site-packages.solcore.material_data.InSb-Material': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\solcore\\material_data\\InSb-Material'], 'venv.Lib.site-packages.solcore.material_data.Levinshtein': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\solcore\\material_data\\Levinshtein'], 'venv.Lib.site-packages.solcore.material_data.Si-Material': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\solcore\\material_data\\Si-Material'], 'venv.Lib.site-packages.solcore.material_data.SOPRA_DB': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\solcore\\material_data\\SOPRA_DB'], 'venv.Lib.site-packages.solcore.material_data.Vurgaftman': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\solcore\\material_data\\Vurgaftman'], 'venv.Lib.site-packages.solcore.material_data.AlGaAs-Material.k': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\solcore\\material_data\\AlGaAs-Material\\k'], 'venv.Lib.site-packages.solcore.material_data.AlGaAs-Material.n': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\solcore\\material_data\\AlGaAs-Material\\n'], 'venv.Lib.site-packages.solcore.material_data.AlInP-Material.k': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\solcore\\material_data\\AlInP-Material\\k'], 'venv.Lib.site-packages.solcore.material_data.AlInP-Material.n': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\solcore\\material_data\\AlInP-Material\\n'], 'venv.Lib.site-packages.solcore.material_data.GaAsP-Material.k': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\solcore\\material_data\\GaAsP-Material\\k'], 'venv.Lib.site-packages.solcore.material_data.GaAsP-Material.n': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\solcore\\material_data\\GaAsP-Material\\n'], 'venv.Lib.site-packages.solcore.material_data.GaInP-Material.k': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\solcore\\material_data\\GaInP-Material\\k'], 'venv.Lib.site-packages.solcore.material_data.GaInP-Material.n': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\solcore\\material_data\\GaInP-Material\\n'], 'venv.Lib.site-packages.solcore.material_data.InGaAs-Material.k': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\solcore\\material_data\\InGaAs-Material\\k'], 'venv.Lib.site-packages.solcore.material_data.InGaAs-Material.n': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\solcore\\material_data\\InGaAs-Material\\n'], 'venv.Lib.site-packages.solcore.material_data.InGaSb-Material.k': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\solcore\\material_data\\InGaSb-Material\\k'], 'venv.Lib.site-packages.solcore.material_data.InGaSb-Material.n': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\solcore\\material_data\\InGaSb-Material\\n'], 'venv.Lib.site-packages.solcore.material_data.SOPRA_DB.ALAS_T': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\solcore\\material_data\\SOPRA_DB\\ALAS_T'], 'venv.Lib.site-packages.solcore.material_data.SOPRA_DB.ALGAAS_AL': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\solcore\\material_data\\SOPRA_DB\\ALGAAS_AL'], 'venv.Lib.site-packages.solcore.material_data.SOPRA_DB.ALGAINP_AL': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\solcore\\material_data\\SOPRA_DB\\ALGAINP_AL'], 'venv.Lib.site-packages.solcore.material_data.SOPRA_DB.GAAS_T': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\solcore\\material_data\\SOPRA_DB\\GAAS_T'], 'venv.Lib.site-packages.solcore.material_data.SOPRA_DB.HGCDTE_CD': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\solcore\\material_data\\SOPRA_DB\\HGCDTE_CD'], 'venv.Lib.site-packages.solcore.material_data.SOPRA_DB.INGASB_GA': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\solcore\\material_data\\SOPRA_DB\\INGASB_GA'], 'venv.Lib.site-packages.solcore.material_data.SOPRA_DB.REINGAAS_IN': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\solcore\\material_data\\SOPRA_DB\\REINGAAS_IN'], 'venv.Lib.site-packages.solcore.material_data.SOPRA_DB.RESIGE_GE': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\solcore\\material_data\\SOPRA_DB\\RESIGE_GE'], 'venv.Lib.site-packages.solcore.material_data.SOPRA_DB.SICR_T': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\solcore\\material_data\\SOPRA_DB\\SICR_T'], 'venv.Lib.site-packages.solcore.material_data.SOPRA_DB.SIGE_SI': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\solcore\\material_data\\SOPRA_DB\\SIGE_SI'], 'venv.Lib.site-packages.solcore.material_data.SOPRA_DB.SION_N': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\solcore\\material_data\\SOPRA_DB\\SION_N'], 'venv.Lib.site-packages.solcore.material_data.SOPRA_DB.SIPOLY_X': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\solcore\\material_data\\SOPRA_DB\\SIPOLY_X'], 'venv.Lib.site-packages.solcore.material_data.SOPRA_DB.STINGAAS_IN': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\solcore\\material_data\\SOPRA_DB\\STINGAAS_IN'], 'venv.Lib.site-packages.solcore.material_data.SOPRA_DB.STSIGE_GE': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\solcore\\material_data\\SOPRA_DB\\STSIGE_GE'], 'venv.Lib.site-packages.solcore.material_data.SOPRA_DB.ZNCDTE_CD': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\solcore\\material_data\\SOPRA_DB\\ZNCDTE_CD'], 'venv.Lib.site-packages.solcore.material_data.SOPRA_DB.ZNSETE_TE': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\solcore\\material_data\\SOPRA_DB\\ZNSETE_TE'], 'venv.Lib.site-packages.terminado._static': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\terminado\\_static'], 'venv.Lib.site-packages.tornado.test.csv_translations': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\tornado\\test\\csv_translations'], 'venv.Lib.site-packages.tornado.test.gettext_translations': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\tornado\\test\\gettext_translations'], 'venv.Lib.site-packages.tornado.test.static': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\tornado\\test\\static'], 'venv.Lib.site-packages.tornado.test.templates': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\tornado\\test\\templates'], 'venv.Lib.site-packages.tornado.test.gettext_translations.fr_FR': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\tornado\\test\\gettext_translations\\fr_FR'], 'venv.Lib.site-packages.tornado.test.gettext_translations.fr_FR.LC_MESSAGES': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\tornado\\test\\gettext_translations\\fr_FR\\LC_MESSAGES'], 'venv.Lib.site-packages.tornado.test.static.dir': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\tornado\\test\\static\\dir'], 'venv.Lib.site-packages.websocket.tests.data': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\websocket\\tests\\data'], 'venv.Lib.site-packages.widgetsnbextension.static': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\widgetsnbextension\\static'], 'venv.Lib.site-packages.win32.Demos': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\win32\\Demos'], 'venv.Lib.site-packages.win32.include': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\win32\\include'], 'venv.Lib.site-packages.win32.lib': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\win32\\lib'], 'venv.Lib.site-packages.win32.libs': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\win32\\libs'], 'venv.Lib.site-packages.win32.scripts': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\win32\\scripts'], 'venv.Lib.site-packages.win32.test': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\win32\\test'], 'venv.Lib.site-packages.win32.Demos.c_extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\win32\\Demos\\c_extension'], 'venv.Lib.site-packages.win32.Demos.dde': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\win32\\Demos\\dde'], 'venv.Lib.site-packages.win32.Demos.images': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\win32\\Demos\\images'], 'venv.Lib.site-packages.win32.Demos.pipes': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\win32\\Demos\\pipes'], 'venv.Lib.site-packages.win32.Demos.security': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\win32\\Demos\\security'], 'venv.Lib.site-packages.win32.Demos.service': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\win32\\Demos\\service'], 'venv.Lib.site-packages.win32.Demos.win32wnet': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\win32\\Demos\\win32wnet'], 'venv.Lib.site-packages.win32.Demos.security.sspi': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\win32\\Demos\\security\\sspi'], 'venv.Lib.site-packages.win32.scripts.VersionStamp': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\win32\\scripts\\VersionStamp'], 'venv.Lib.site-packages.win32.test.win32rcparser': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\win32\\test\\win32rcparser'], 'venv.Lib.site-packages.win32com.HTML': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\win32com\\HTML'], 'venv.Lib.site-packages.win32com.include': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\win32com\\include'], 'venv.Lib.site-packages.win32com.libs': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\win32com\\libs'], 'venv.Lib.site-packages.win32com.HTML.image': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\win32com\\HTML\\image'], 'venv.Lib.site-packages.win32comext.adsi.demos': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\win32comext\\adsi\\demos'], 'venv.Lib.site-packages.win32comext.authorization.demos': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\win32comext\\authorization\\demos'], 'venv.Lib.site-packages.win32comext.axscript.Demos': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\win32comext\\axscript\\Demos'], 'venv.Lib.site-packages.win32comext.axscript.test': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\win32comext\\axscript\\test'], 'venv.Lib.site-packages.win32comext.axscript.Demos.client': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\win32comext\\axscript\\Demos\\client'], 'venv.Lib.site-packages.win32comext.axscript.Demos.client.asp': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\win32comext\\axscript\\Demos\\client\\asp'], 'venv.Lib.site-packages.win32comext.axscript.Demos.client.ie': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\win32comext\\axscript\\Demos\\client\\ie'], 'venv.Lib.site-packages.win32comext.axscript.Demos.client.wsh': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\win32comext\\axscript\\Demos\\client\\wsh'], 'venv.Lib.site-packages.win32comext.axscript.Demos.client.asp.interrupt': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\win32comext\\axscript\\Demos\\client\\asp\\interrupt'], 'venv.Lib.site-packages.win32comext.bits.test': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\win32comext\\bits\\test'], 'venv.Lib.site-packages.win32comext.ifilter.demo': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\win32comext\\ifilter\\demo'], 'venv.Lib.site-packages.win32comext.mapi.demos': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\win32comext\\mapi\\demos'], 'venv.Lib.site-packages.win32comext.propsys.test': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\win32comext\\propsys\\test'], 'venv.Lib.site-packages.win32comext.shell.demos': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\win32comext\\shell\\demos'], 'venv.Lib.site-packages.win32comext.shell.test': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\win32comext\\shell\\test'], 'venv.Lib.site-packages.win32comext.shell.demos.servers': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\win32comext\\shell\\demos\\servers'], 'venv.Lib.site-packages.win32comext.taskscheduler.test': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\Lib\\site-packages\\win32comext\\taskscheduler\\test'], 'venv.share.applications': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\applications'], 'venv.share.icons': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\icons'], 'venv.share.jupyter': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter'], 'venv.share.man': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\man'], 'venv.share.icons.hicolor': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\icons\\hicolor'], 'venv.share.icons.hicolor.scalable': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\icons\\hicolor\\scalable'], 'venv.share.icons.hicolor.scalable.apps': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\icons\\hicolor\\scalable\\apps'], 'venv.share.jupyter.kernels': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\kernels'], 'venv.share.jupyter.lab': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab'], 'venv.share.jupyter.labextensions': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\labextensions'], 'venv.share.jupyter.nbconvert': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\nbconvert'], 'venv.share.jupyter.nbextensions': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\nbextensions'], 'venv.share.jupyter.kernels.python3': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\kernels\\python3'], 'venv.share.jupyter.lab.schemas': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\schemas'], 'venv.share.jupyter.lab.static': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\static'], 'venv.share.jupyter.lab.themes': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\themes'], 'venv.share.jupyter.lab.schemas.@jupyter-notebook': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\schemas\\@jupyter-notebook'], 'venv.share.jupyter.lab.schemas.@jupyterlab': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\schemas\\@jupyterlab'], 'venv.share.jupyter.lab.schemas.@jupyter-notebook.application-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\schemas\\@jupyter-notebook\\application-extension'], 'venv.share.jupyter.lab.schemas.@jupyter-notebook.documentsearch-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\schemas\\@jupyter-notebook\\documentsearch-extension'], 'venv.share.jupyter.lab.schemas.@jupyter-notebook.help-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\schemas\\@jupyter-notebook\\help-extension'], 'venv.share.jupyter.lab.schemas.@jupyter-notebook.notebook-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\schemas\\@jupyter-notebook\\notebook-extension'], 'venv.share.jupyter.lab.schemas.@jupyter-notebook.tree-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\schemas\\@jupyter-notebook\\tree-extension'], 'venv.share.jupyter.lab.schemas.@jupyterlab.application-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\schemas\\@jupyterlab\\application-extension'], 'venv.share.jupyter.lab.schemas.@jupyterlab.apputils-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\schemas\\@jupyterlab\\apputils-extension'], 'venv.share.jupyter.lab.schemas.@jupyterlab.cell-toolbar-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\schemas\\@jupyterlab\\cell-toolbar-extension'], 'venv.share.jupyter.lab.schemas.@jupyterlab.celltags-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\schemas\\@jupyterlab\\celltags-extension'], 'venv.share.jupyter.lab.schemas.@jupyterlab.codemirror-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\schemas\\@jupyterlab\\codemirror-extension'], 'venv.share.jupyter.lab.schemas.@jupyterlab.completer-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\schemas\\@jupyterlab\\completer-extension'], 'venv.share.jupyter.lab.schemas.@jupyterlab.console-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\schemas\\@jupyterlab\\console-extension'], 'venv.share.jupyter.lab.schemas.@jupyterlab.csvviewer-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\schemas\\@jupyterlab\\csvviewer-extension'], 'venv.share.jupyter.lab.schemas.@jupyterlab.debugger-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\schemas\\@jupyterlab\\debugger-extension'], 'venv.share.jupyter.lab.schemas.@jupyterlab.docmanager-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\schemas\\@jupyterlab\\docmanager-extension'], 'venv.share.jupyter.lab.schemas.@jupyterlab.documentsearch-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\schemas\\@jupyterlab\\documentsearch-extension'], 'venv.share.jupyter.lab.schemas.@jupyterlab.extensionmanager-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\schemas\\@jupyterlab\\extensionmanager-extension'], 'venv.share.jupyter.lab.schemas.@jupyterlab.filebrowser-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\schemas\\@jupyterlab\\filebrowser-extension'], 'venv.share.jupyter.lab.schemas.@jupyterlab.fileeditor-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\schemas\\@jupyterlab\\fileeditor-extension'], 'venv.share.jupyter.lab.schemas.@jupyterlab.help-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\schemas\\@jupyterlab\\help-extension'], 'venv.share.jupyter.lab.schemas.@jupyterlab.htmlviewer-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\schemas\\@jupyterlab\\htmlviewer-extension'], 'venv.share.jupyter.lab.schemas.@jupyterlab.hub-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\schemas\\@jupyterlab\\hub-extension'], 'venv.share.jupyter.lab.schemas.@jupyterlab.imageviewer-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\schemas\\@jupyterlab\\imageviewer-extension'], 'venv.share.jupyter.lab.schemas.@jupyterlab.inspector-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\schemas\\@jupyterlab\\inspector-extension'], 'venv.share.jupyter.lab.schemas.@jupyterlab.launcher-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\schemas\\@jupyterlab\\launcher-extension'], 'venv.share.jupyter.lab.schemas.@jupyterlab.logconsole-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\schemas\\@jupyterlab\\logconsole-extension'], 'venv.share.jupyter.lab.schemas.@jupyterlab.lsp-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\schemas\\@jupyterlab\\lsp-extension'], 'venv.share.jupyter.lab.schemas.@jupyterlab.mainmenu-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\schemas\\@jupyterlab\\mainmenu-extension'], 'venv.share.jupyter.lab.schemas.@jupyterlab.markdownviewer-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\schemas\\@jupyterlab\\markdownviewer-extension'], 'venv.share.jupyter.lab.schemas.@jupyterlab.mathjax-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\schemas\\@jupyterlab\\mathjax-extension'], 'venv.share.jupyter.lab.schemas.@jupyterlab.metadataform-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\schemas\\@jupyterlab\\metadataform-extension'], 'venv.share.jupyter.lab.schemas.@jupyterlab.notebook-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\schemas\\@jupyterlab\\notebook-extension'], 'venv.share.jupyter.lab.schemas.@jupyterlab.running-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\schemas\\@jupyterlab\\running-extension'], 'venv.share.jupyter.lab.schemas.@jupyterlab.settingeditor-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\schemas\\@jupyterlab\\settingeditor-extension'], 'venv.share.jupyter.lab.schemas.@jupyterlab.shortcuts-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\schemas\\@jupyterlab\\shortcuts-extension'], 'venv.share.jupyter.lab.schemas.@jupyterlab.statusbar-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\schemas\\@jupyterlab\\statusbar-extension'], 'venv.share.jupyter.lab.schemas.@jupyterlab.terminal-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\schemas\\@jupyterlab\\terminal-extension'], 'venv.share.jupyter.lab.schemas.@jupyterlab.toc-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\schemas\\@jupyterlab\\toc-extension'], 'venv.share.jupyter.lab.schemas.@jupyterlab.tooltip-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\schemas\\@jupyterlab\\tooltip-extension'], 'venv.share.jupyter.lab.schemas.@jupyterlab.translation-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\schemas\\@jupyterlab\\translation-extension'], 'venv.share.jupyter.lab.schemas.@jupyterlab.workspaces-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\schemas\\@jupyterlab\\workspaces-extension'], 'venv.share.jupyter.lab.themes.@jupyterlab': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\themes\\@jupyterlab'], 'venv.share.jupyter.lab.themes.@jupyterlab.theme-dark-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\themes\\@jupyterlab\\theme-dark-extension'], 'venv.share.jupyter.lab.themes.@jupyterlab.theme-dark-high-contrast-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\themes\\@jupyterlab\\theme-dark-high-contrast-extension'], 'venv.share.jupyter.lab.themes.@jupyterlab.theme-light-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\lab\\themes\\@jupyterlab\\theme-light-extension'], 'venv.share.jupyter.labextensions.@jupyter-notebook': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\labextensions\\@jupyter-notebook'], 'venv.share.jupyter.labextensions.@jupyter-widgets': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\labextensions\\@jupyter-widgets'], 'venv.share.jupyter.labextensions.jupyterlab_pygments': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\labextensions\\jupyterlab_pygments'], 'venv.share.jupyter.labextensions.@jupyter-notebook.lab-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\labextensions\\@jupyter-notebook\\lab-extension'], 'venv.share.jupyter.labextensions.@jupyter-notebook.lab-extension.schemas': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\labextensions\\@jupyter-notebook\\lab-extension\\schemas'], 'venv.share.jupyter.labextensions.@jupyter-notebook.lab-extension.static': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\labextensions\\@jupyter-notebook\\lab-extension\\static'], 'venv.share.jupyter.labextensions.@jupyter-notebook.lab-extension.schemas.@jupyter-notebook': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\labextensions\\@jupyter-notebook\\lab-extension\\schemas\\@jupyter-notebook'], 'venv.share.jupyter.labextensions.@jupyter-notebook.lab-extension.schemas.@jupyter-notebook.lab-extension': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\labextensions\\@jupyter-notebook\\lab-extension\\schemas\\@jupyter-notebook\\lab-extension'], 'venv.share.jupyter.labextensions.@jupyter-widgets.jupyterlab-manager': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\labextensions\\@jupyter-widgets\\jupyterlab-manager'], 'venv.share.jupyter.labextensions.@jupyter-widgets.jupyterlab-manager.schemas': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\labextensions\\@jupyter-widgets\\jupyterlab-manager\\schemas'], 'venv.share.jupyter.labextensions.@jupyter-widgets.jupyterlab-manager.static': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\labextensions\\@jupyter-widgets\\jupyterlab-manager\\static'], 'venv.share.jupyter.labextensions.@jupyter-widgets.jupyterlab-manager.schemas.@jupyter-widgets': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\labextensions\\@jupyter-widgets\\jupyterlab-manager\\schemas\\@jupyter-widgets'], 'venv.share.jupyter.labextensions.@jupyter-widgets.jupyterlab-manager.schemas.@jupyter-widgets.jupyterlab-manager': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\labextensions\\@jupyter-widgets\\jupyterlab-manager\\schemas\\@jupyter-widgets\\jupyterlab-manager'], 'venv.share.jupyter.labextensions.jupyterlab_pygments.static': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\labextensions\\jupyterlab_pygments\\static'], 'venv.share.jupyter.nbconvert.templates': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\nbconvert\\templates'], 'venv.share.jupyter.nbconvert.templates.asciidoc': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\nbconvert\\templates\\asciidoc'], 'venv.share.jupyter.nbconvert.templates.base': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\nbconvert\\templates\\base'], 'venv.share.jupyter.nbconvert.templates.basic': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\nbconvert\\templates\\basic'], 'venv.share.jupyter.nbconvert.templates.classic': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\nbconvert\\templates\\classic'], 'venv.share.jupyter.nbconvert.templates.compatibility': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\nbconvert\\templates\\compatibility'], 'venv.share.jupyter.nbconvert.templates.lab': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\nbconvert\\templates\\lab'], 'venv.share.jupyter.nbconvert.templates.latex': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\nbconvert\\templates\\latex'], 'venv.share.jupyter.nbconvert.templates.markdown': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\nbconvert\\templates\\markdown'], 'venv.share.jupyter.nbconvert.templates.python': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\nbconvert\\templates\\python'], 'venv.share.jupyter.nbconvert.templates.reveal': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\nbconvert\\templates\\reveal'], 'venv.share.jupyter.nbconvert.templates.rst': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\nbconvert\\templates\\rst'], 'venv.share.jupyter.nbconvert.templates.script': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\nbconvert\\templates\\script'], 'venv.share.jupyter.nbconvert.templates.webpdf': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\nbconvert\\templates\\webpdf'], 'venv.share.jupyter.nbconvert.templates.classic.static': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\nbconvert\\templates\\classic\\static'], 'venv.share.jupyter.nbconvert.templates.lab.static': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\nbconvert\\templates\\lab\\static'], 'venv.share.jupyter.nbconvert.templates.reveal.static': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\nbconvert\\templates\\reveal\\static'], 'venv.share.jupyter.nbextensions.jupyter-js-widgets': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\jupyter\\nbextensions\\jupyter-js-widgets'], 'venv.share.man.man1': ['C:\\Users\\tdrumond\\Repos\\SolPOC\\venv\\share\\man\\man1'], 'Examples': []}
PATH_PLACEHOLDER = '__editable__.solpoc-0.9.4.finder' + ".__path_hook__"


class _EditableFinder:  # MetaPathFinder
    @classmethod
    def find_spec(cls, fullname: str, path=None, target=None) -> ModuleSpec | None:  # type: ignore
        # Top-level packages and modules (we know these exist in the FS)
        if fullname in MAPPING:
            pkg_path = MAPPING[fullname]
            return cls._find_spec(fullname, Path(pkg_path))

        # Handle immediate children modules (required for namespaces to work)
        # To avoid problems with case sensitivity in the file system we delegate
        # to the importlib.machinery implementation.
        parent, _, child = fullname.rpartition(".")
        if parent and parent in MAPPING:
            return PathFinder.find_spec(fullname, path=[MAPPING[parent]])

        # Other levels of nesting should be handled automatically by importlib
        # using the parent path.
        return None

    @classmethod
    def _find_spec(cls, fullname: str, candidate_path: Path) -> ModuleSpec | None:
        init = candidate_path / "__init__.py"
        candidates = (candidate_path.with_suffix(x) for x in module_suffixes())
        for candidate in chain([init], candidates):
            if candidate.exists():
                return spec_from_file_location(fullname, candidate)
        return None


class _EditableNamespaceFinder:  # PathEntryFinder
    @classmethod
    def _path_hook(cls, path) -> type[_EditableNamespaceFinder]:
        if path == PATH_PLACEHOLDER:
            return cls
        raise ImportError

    @classmethod
    def _paths(cls, fullname: str) -> list[str]:
        paths = NAMESPACES[fullname]
        if not paths and fullname in MAPPING:
            paths = [MAPPING[fullname]]
        # Always add placeholder, for 2 reasons:
        # 1. __path__ cannot be empty for the spec to be considered namespace.
        # 2. In the case of nested namespaces, we need to force
        #    import machinery to query _EditableNamespaceFinder again.
        return [*paths, PATH_PLACEHOLDER]

    @classmethod
    def find_spec(cls, fullname: str, target=None) -> ModuleSpec | None:  # type: ignore
        if fullname in NAMESPACES:
            spec = ModuleSpec(fullname, None, is_package=True)
            spec.submodule_search_locations = cls._paths(fullname)
            return spec
        return None

    @classmethod
    def find_module(cls, _fullname) -> None:
        return None


def install():
    if not any(finder == _EditableFinder for finder in sys.meta_path):
        sys.meta_path.append(_EditableFinder)

    if not NAMESPACES:
        return

    if not any(hook == _EditableNamespaceFinder._path_hook for hook in sys.path_hooks):
        # PathEntryFinder is needed to create NamespaceSpec without private APIS
        sys.path_hooks.append(_EditableNamespaceFinder._path_hook)
    if PATH_PLACEHOLDER not in sys.path:
        sys.path.append(PATH_PLACEHOLDER)  # Used just to trigger the path hook
